/*
    reloader.h - definitions file for IDA loader
*/

#ifndef __RELOADER_H__
#define __RELOADER_H__

#include <ida.hpp>

struct dos_header {
short e_magic;
short e_cblp;
short  e_cp;
short  e_crlc;
short  e_cparhdr;
short  e_minalloc;
short  e_maxalloc;
short  e_ss;
short  e_sp;
short  e_csum;
short  e_ip;
short e_cs;
short e_farlc;
short e_ovno;
char e_res[8];
short e_oemid;
short e_oeminfo;
char e_res2[20];
int e_lfanew;
};


struct nt_header {
int Signature;
short Machine;
short NumberOfSection;
int TimeDateStamp;
int PtrSymbolTable;
int NumberOfSymbol;
short SizeOfOptionalHeader;
short Characteristics;
};


struct optional_header {
short Magic;
char MajorLinkVer;
char MinorLinkVer;
int SizeOfCode;
int SizeOfInitializedData;
int SizeOfUninitializedData;
int AddressOfEntryPoint;
int BaseOfCode;
int BaseOfData;
int BaseOfImage;
int SectionAlignment;
int FileAlignment;
};


struct section_header {
char name[8];
int VirtualSize;
int VirtualAddress;
int SizeOfRawData;
int PointereToRawData;
int PointerToRelocation;
int PointerToLinenumbers;
short NumberOfRelocations;
short NumberOfLinenumbers;
int Characteristics;
};

const int RE_MAGIC = 0x904552;

#endif
